## skimage 0.12.3

=== Makefile ===
.PHONY: all clean test
PYTHON=python
NOSETESTS=nosetests

all:
	$(PYTHON) setup.py build_ext --inplace

clean:
	find . -name "*.so" -o -name "*.pyc" -o -name "*.pyx.md5" -o -name "*.pyd" | xargs rm -f
	find . -name "*.pyx" -exec ./tools/rm_pyx_c_file.sh {} \;

test:
	$(PYTHON) -c "import skimage, sys, io; sys.exit(skimage.test_verbose())"

doctest:
	$(PYTHON) -c "import skimage, sys, io; sys.exit(skimage.doctest_verbose())"

coverage:
	$(NOSETESTS) skimage --with-coverage --cover-package=skimage

html:
	pip install -q sphinx
	export SPHINXOPTS=-W; make -C doc html

=== requirements.txt ===
matplotlib>=1.3.1
numpy>=1.7.2
scipy>=0.9.0
six>=1.7.3
networkx>=1.8
pillow>=2.1.0
dask[array]>=0.5.0

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
PYTHON        ?= python
SPHINXOPTS    ?=
SPHINXBUILD   ?= python $(shell which sphinx-build)
SPHINXCACHE   ?= build/doctrees
PAPER         ?=

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(SPHINXCACHE) $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
DEST = build
.PHONY: all help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest gitwash gh-pages release_notes

all: html

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  devhelp   to make HTML files and a Devhelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf  to make LaTeX files and run them through pdflatex"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"
	@echo "  gitwash   to update the gitwash documentation"
clean:
	-rm -rf $(DEST)/*
	-rm -rf source/api
	-find ./source/auto_examples/* -type f | grep -v blank | xargs rm -f
api:
	@mkdir -p source/api
	$(PYTHON) tools/build_modref_templates.py
	@echo "Build API docs...done."

release_notes:
	@echo "Copying release notes"
	@tail -n +4 `ls release/*.txt | sort -k 2 -t . -n | tail -n 1` > release/_release_notes_for_docs.txt

html: api release_notes
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(DEST)/html
	cp -r source/plots $(DEST)/html
	@echo
	@echo "Build finished. The HTML pages are in build/html."
	$(PYTHON) source/random_gallery.py

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(DEST)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in build/dirhtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(DEST)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(DEST)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(DEST)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in build/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(DEST)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in build/qthelp, like this:"
	@echo "# qcollectiongenerator build/qthelp/scikitimage.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile build/qthelp/scikitimage.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(DEST)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/scikitimage"
	@echo "# ln -s build/devhelp $$HOME/.local/share/devhelp/scikitimage"
	@echo "# devhelp"

latex: api
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(DEST)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(DEST)/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

latexpdf: latex
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(DEST)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C build/latex all-pdf
	@echo "pdflatex finished; the PDF files are in build/latex."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(DEST)/changes
	@echo
	@echo "The overview file is in build/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(DEST)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in build/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(DEST)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in build/doctest/output.txt."

gh-pages:
	$(PYTHON) gh-pages.py

gitwash:
	$(PYTHON) tools/gitwash/gitwash_dumper.py source scikit-image \
	--project-url=http://scikit-image.org \
	--project-ml-url=http://groups.google.com/group/scikit-image \
	--repo-name=scikit-image \
	--github-user=scikit-image \
	--source-suffix=.txt

=== tools/appveyor/requirements.txt ===
# Fetch numpy and scipy wheels from the sklearn rackspace wheelhouse.
# Those wheels were generated by @ogrisel by calling `wheel convert` on
# the binaries from http://www.lfd.uci.edu/~gohlke/pythonlibs/
# This is a temporary solution. As soon as numpy, scipy and cython provide
# official wheels for windows we can delete this --find-links line.
--find-links http://28daf2247a33ed269873-7b1aad3fab3cc330e1fd9d109892382a.r6.cf2.rackcdn.com/appveyor_pip_index.html

# fix the versions of binary packages to force the use of the whl
# of the rackspace folder instead of trying to install from PyPI
# wheels are preferred for a given version
numpy==1.8.1
scipy==0.14.0
cython>=0.21
matplotlib==1.4.2
pillow==2.6.1
wheel
nose

=== debian/changelog ===
skimage (0.12.3-9) unstable; urgency=medium

  * Team upload.
  * Fix build with nocheck.
  * Mark python3-skimage-lib as Multi-Arch:same.
  * Mark python-skimage-doc as Multi-Arch:foreign.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 28 Apr 2017 11:24:32 +0200

skimage (0.12.3-8) unstable; urgency=medium

  * Re-enable tests since numpy bug #849196 is fixed now

 -- Ole Streicher <olebole@debian.org>  Sat, 07 Jan 2017 14:51:42 +0100

skimage (0.12.3-7) unstable; urgency=medium

  * Team upload.
  * Remove piwik privacy breach

 -- Ole Streicher <olebole@debian.org>  Sat, 24 Dec 2016 13:46:17 +0100

skimage (0.12.3-6) unstable; urgency=medium

  * Team upload.
  * Fix typo in d/rules

 -- Ole Streicher <olebole@debian.org>  Sat, 24 Dec 2016 12:07:22 +0100

skimage (0.12.3-5) unstable; urgency=medium

  * Team upload.
  * Temporarily disable build time tests completely to fix FTBFS.
    Currently, the only fix is related to a bug in the tests infrastructure,
    either of numpy or of skimage. Until this is fixed, the tests are
    disabled completely to ensure the migration of an otherwise working
    package to testing. CI tests are still enabled.

 -- Ole Streicher <olebole@debian.org>  Sat, 24 Dec 2016 08:42:50 +0100

skimage (0.12.3-4) unstable; urgency=medium

  * Team upload.
  * Hide another failed test (on i386)

 -- Ole Streicher <olebole@debian.org>  Fri, 23 Dec 2016 17:45:36 +0100

skimage (0.12.3-3) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * Moved to Debian Science team maintenance
  * Drop debian/gbp.conf declaring branches and tag names different from
    Debian Science policy
  * Add patch to ignore those tests that are failing on some architectures
    This addresses bug #840589 and I would consider it apropriate to reduce
    the severity of the bug until further investigation of the issues at
    these architectures

  [ Ole Streicher ]
  * Remove dependency from python-dask. Closes: #848112
  * Explicitely use integer as number of bins to fix FTBFS with numpy
    1.12~
  * Hide a (possible) numpy test bug
  * Add bootstrap.js to d/missing-sources as source of bootstrap.min.js

 -- Ole Streicher <olebole@debian.org>  Fri, 23 Dec 2016 12:07:13 +0100

skimage (0.12.3-2) unstable; urgency=medium

  * debian/patches
    - changeset_6807f4ee8f5501703e447f95701190c836deaae1.diff to initialize
      value of firstbg to avoid segfaults (Closes: #840589)

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 12 Dec 2016 12:41:31 -0500

skimage (0.12.3-1) unstable; urgency=medium

  [ Stefan van der Walt ]
  * Fresh upstream release
    - Removes lena images (Closes: #794859)
    - Removes freeimage plugin (Closes: #783818)
    - Fixes Sphinx 1.3 incompatibility (Closes: #788965)
  * debian/watch now uses scikit-image-*.*.tar.gz as filename
  * Patch: turn dask into an optional dependency
  * debian/control
    - boosted policy to 3.9.8
  * debian/copyright
    - Update license for tifffile
    - Add imagej license for threshold_li
    - Add license for canny edge detector

  [ Gianfranco Costamagna ]
  * VCS fields in https mode.
  * Drop useless XS testsuite in control file.
  * Fix copyright file
  * Update Stefan mail address

  [ Yaroslav Halchenko ]
  * Fresh upstream release (previous version, never uploaded)
    - includes slicing-error.patch freeimage-fix.patch
  * Updated debian/watch to avoid deprecated redirector
  * debian/{,tests/}control
    - added python{,3}-networkx to {build-,}depends and Recommends
  * debian/tests/python*
    - for now exclude testing of test_tools.py due to #779847 in mpl

 -- Stefan van der Walt <stefanv@berkeley.edu>  Mon, 23 May 2016 11:11:52 +0200

=== debian/control ===
Source: skimage
Section: python
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Stefan van der Walt <stefanv@berkeley.edu>,
           Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: cython (>= 0.23),
               cython3 (>= 0.23),
               debhelper (>= 9~),
               libjs-twitter-bootstrap,
               python-all-dev (>= 2.6.6-3~),
               python-matplotlib (>= 1.3.1),
               python-nose,
               python-numpy (>= 1.7.2),
               python-pil (>= 1.7.8) | python-imaging,
               python-scipy (>= 0.10),
               python-networkx (>= 1.8),
               python-setuptools,
               python-six (>= 1.4),
               python-sphinx (>= 1.3.0),
               python3-all-dev,
               python3-matplotlib (>= 1.3.1),
               python3-nose,
               python3-numpy (>= 1.7.2),
               python3-pil (>= 1.7.8) | python3-imaging,
               python3-scipy,
               python3-networkx (>= 1.8),
               python3-setuptools,
               python3-six (>= 1.3.0),
               xauth,
               xvfb
Standards-Version: 3.9.8
Homepage: http://scikit-image.org
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/skimage.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/skimage.git
X-Python-Version: >= 2.6
X-Python3-Version: >= 3.2

Package: python-skimage
Architecture: all
Depends: python-numpy,
         python-scipy (>= 0.10),
         python-six (>= 1.4),
         python-matplotlib (>= 1.3.1),
         python-pil (>= 1.7.8) | python-imaging,
         python-networkx (>= 1.8),
         python-skimage-lib (>= ${source:Version}),
         ${misc:Depends},
         ${python:Depends}
Recommends: python-nose,
            python-qt4
Suggests: python-opencv, python-skimage-doc
Description: Python modules for image processing
 scikit-image is a collection of image processing algorithms for
 Python.  It performs tasks such as image loading, filtering,
 morphology, segmentation, color conversions, and transformations.
 .
 This package provides the Python 2 module.

Package: python3-skimage
Architecture: all
Depends: python3-numpy (>= 1.7.2),
         python3-scipy (>= 0.10),
         python3-six (>= 1.4),
         python3-matplotlib (>= 1.3.1),
         python3-pil (>= 1.7.8) | python3-imaging,
         python3-networkx (>= 1.8),
         python3-skimage-lib (>= ${source:Version}),
         ${misc:Depends},
         ${python3:Depends}
Recommends: python3-nose
Suggests: python-skimage-doc
Description: Python 3 modules for image processing
 scikit-image is a collection of image processing algorithms for
 Python.  It performs tasks such as image loading, filtering,
 morphology, segmentation, color conversions, and transformations.
 .
 This package provides the Python 3 module.

Package: python-skimage-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: python-skimage
Description: Documentation and examples for scikit-image
 This package contains documentation and example scripts for
 python-skimage.

Package: python-skimage-lib
Architecture: any
Depends: python-numpy, ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Recommends: python-skimage
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Description: Optimized low-level algorithms for scikit-image
 This is an add-on package for python-skimage. It provides
 optimized, low-level implementations of algorithms.
 .
 This package provides the Python 2 libraries.

Package: python3-skimage-lib
Architecture: any
Multi-Arch: same
Depends: python3-numpy, ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Recommends: python3-skimage
Description: Optimized low-level algorithms for Python 3 scikit-image
 This is an add-on package for python-skimage. It provides
 optimized, low-level implementations of algorithms.
 .
 This package provides the Python 3 libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

PACKAGE2_NAME = python-skimage
PACKAGE3_NAME = python3-skimage
PKG_TMP = $(CURDIR)/debian/tmp
# don't optimize pngs, palette changes break tests and documented examples
export NO_PNG_PKG_MANGLE=1

PYVERS = $(shell pyversions -vr)
PYVER = $(shell pyversions  -vd)
PY3VERS = $(shell py3versions -vr)

# upstream relies on signed chars
export DEB_CFLAGS_MAINT_APPEND := -fsigned-char

export MPLCONFIGDIR=$(CURDIR)/build
export HOME=$(CURDIR)/build

export http_proxy = http://127.0.9.1:9
export https_proxy = http://127.0.9.1:9

# Mega rule
%:
	dh $@ --with python2,python3,sphinxdoc --buildsystem python_distutils

override_dh_clean:
	rm -f install-stamp
ifeq (,$(filter noclean,$(DEB_BUILD_OPTIONS)))
	rm -rf build doc/build doc/auto_examples *-stamp skimage.egg-info
	dh_clean
endif

# Assure Agg backend for matplotlib to avoid any possible complication
override_dh_auto_configure:
	mkdir -p $(MPLCONFIGDIR)
	echo "backend : Agg" >| $(MPLCONFIGDIR)/matplotlibrc
	dh_auto_configure

# Build docs during install
override_dh_auto_install: ${PYVERS:%=python-install%} ${PY3VERS:%=python-install%}
	: # Build Documentation
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
ifneq (,$(findstring -a,$(DH_INTERNAL_OPTIONS)))
	: # not building documentation in -a
else
	export PYTHONPATH=$(PKG_TMP)/usr/lib/python$(PYVER)/dist-packages; \
	 cd doc; test -d build/html || $(MAKE) html
endif
endif
	touch install-stamp

# Per Python version logic -- install, test, move .so into -lib
python-install%:
	python$* setup.py install --install-layout=deb --root=$(CURDIR)/debian/tmp

python-test%: install-stamp
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	pkgbuild=yes debian/tests/python$*
else
	: # Skip unittests due to nocheck
endif

## remove .so libraries from main package, and call dh_numpy*
_dh_python%: python-test%
	-find debian/$(PACKAGE$*_NAME)/usr/lib -name "*.so" -delete;

	dh_numpy$(*:2=) -p$(PACKAGE$*_NAME)-lib
	dh_python$*

override_dh_python2: _dh_python2
override_dh_python3: _dh_python3

## immediately useable documentation and exemplar scripts/data
override_dh_compress:
	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc

override_dh_sphinxdoc:
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
ifneq (,$(findstring -a,$(DH_INTERNAL_OPTIONS)))
	: # no documentation in -a -- surprised that sphinxdoc doesn't know that
else
	dh_sphinxdoc -ppython-skimage-doc
endif
endif

override_dh_installdocs:
	dh_installdocs -A CONTRIBUTORS.txt README.md CONTRIBUTING.txt TASKS.txt
	dh_link -ppython-skimage-doc /usr/share/twitter-bootstrap/files/js/bootstrap.min.js \
	    usr/share/doc/python-skimage-doc/html/_static/js/bootstrap.min.js
	dh_link -ppython-skimage-doc /usr/share/twitter-bootstrap/files/css/bootstrap.min.css \
	    usr/share/doc/python-skimage-doc/html/_static/css/bootstrap.min.css
	dh_link -ppython-skimage-doc /usr/share/twitter-bootstrap/files/css/bootstrap-responsive.css \
	    usr/share/doc/python-skimage-doc/html/_static/css/bootstrap-responsive.css

## skimage 0.13.0

=== Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 	$(PYTHON) setup.py build_ext --inplace
 
 clean:
-	find . -name "*.so" -o -name "*.pyc" -o -name "*.pyx.md5" -o -name "*.pyd" | xargs rm -f
+	find . -name "*.so" -o -name "*.pyc" -o -name "*.md5" -o -name "*.pyd" | xargs rm -f
 	find . -name "*.pyx" -exec ./tools/rm_pyx_c_file.sh {} \;
 
 test:

=== debian/changelog ===
skimage (0.13.0-0ubuntu4) artful; urgency=medium

  * No-change rebuild to drop _PyFPE support.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 05 Sep 2017 08:23:54 +0000

skimage (0.13.0-0ubuntu3) artful; urgency=medium

  * No-change rebuild to build to drop python3.5.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 05 Aug 2017 18:40:54 +0000

skimage (0.13.0-0ubuntu2) artful; urgency=medium

  * Add d/patches/fix-docs-build.patch to fix ftbfs caused by new version of
    numpydoc.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 17 Jul 2017 12:54:37 +1200

skimage (0.13.0-0ubuntu1) artful; urgency=medium

  * New upstream release.
  * d/patches/:
    - changeset_6807f4ee8f5501703e447f95701190c836deaae1.diff,
      dask-optional-dep.patch, fix_shape_type.patch, search-html.patch: dropped,
      applied upstream.
    - fix-doc-links.patch: updated
    - skip_tests_failing_on_some_architectures.patch: split into more targetted
      skip-failing-test-on-i386.patch & skip-failing-test-on-big-endian.patch.
  * d/rules: CONTRIBUTING.txt has moved.
  * d/control: add dependencies on python{3,}-pywt. python{3,}-numpydoc.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 14 Jul 2017 12:34:25 +1200

skimage (0.12.3-9build1) artful; urgency=medium

  * No change rebuild to add Python 3.6 support.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 07 Jun 2017 16:32:15 -0700

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: skimage
 Section: python
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Stefan van der Walt <stefanv@berkeley.edu>,
            Yaroslav Halchenko <debian@onerussian.com>
 Build-Depends: cython (>= 0.23),
@@ -10,21 +11,25 @@
                libjs-twitter-bootstrap,
                python-all-dev (>= 2.6.6-3~),
                python-matplotlib (>= 1.3.1),
+               python-networkx (>= 1.8),
                python-nose,
                python-numpy (>= 1.7.2),
+               python-numpydoc,
                python-pil (>= 1.7.8) | python-imaging,
+               python-pywt,
                python-scipy (>= 0.10),
-               python-networkx (>= 1.8),
                python-setuptools,
                python-six (>= 1.4),
                python-sphinx (>= 1.3.0),
                python3-all-dev,
                python3-matplotlib (>= 1.3.1),
+               python3-networkx (>= 1.8),
                python3-nose,
                python3-numpy (>= 1.7.2),
+               python3-numpydoc,
                python3-pil (>= 1.7.8) | python3-imaging,
+               python3-pywt,
                python3-scipy,
-               python3-networkx (>= 1.8),
                python3-setuptools,
                python3-six (>= 1.3.0),
                xauth,
@@ -38,17 +43,16 @@
 
 Package: python-skimage
 Architecture: all
-Depends: python-numpy,
+Depends: python-matplotlib (>= 1.3.1),
+         python-networkx (>= 1.8),
+         python-numpy,
+         python-pil (>= 1.7.8) | python-imaging,
          python-scipy (>= 0.10),
          python-six (>= 1.4),
-         python-matplotlib (>= 1.3.1),
-         python-pil (>= 1.7.8) | python-imaging,
-         python-networkx (>= 1.8),
          python-skimage-lib (>= ${source:Version}),
          ${misc:Depends},
          ${python:Depends}
-Recommends: python-nose,
-            python-qt4
+Recommends: python-nose, python-qt4
 Suggests: python-opencv, python-skimage-doc
 Description: Python modules for image processing
  scikit-image is a collection of image processing algorithms for
@@ -59,12 +63,12 @@
 
 Package: python3-skimage
 Architecture: all
-Depends: python3-numpy (>= 1.7.2),
+Depends: python3-matplotlib (>= 1.3.1),
+         python3-networkx (>= 1.8),
+         python3-numpy (>= 1.7.2),
+         python3-pil (>= 1.7.8) | python3-imaging,
          python3-scipy (>= 0.10),
          python3-six (>= 1.4),
-         python3-matplotlib (>= 1.3.1),
-         python3-pil (>= 1.7.8) | python3-imaging,
-         python3-networkx (>= 1.8),
          python3-skimage-lib (>= ${source:Version}),
          ${misc:Depends},
          ${python3:Depends}

## skimage 0.13.1

=== Makefile ===
--- 
+++ 
@@ -19,5 +19,5 @@
 	$(NOSETESTS) skimage --with-coverage --cover-package=skimage
 
 html:
-	pip install -q sphinx
+	pip install -q sphinx pytest-runner sphinx-gallery
 	export SPHINXOPTS=-W; make -C doc html

=== requirements.txt ===
matplotlib>=1.3.1
numpy>=1.11
scipy>=0.17.0
six>=1.7.3
networkx>=1.8
pillow>=2.1.0
PyWavelets>=0.4.0

=== doc/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 # You can set these variables from the command line.
 PYTHON        ?= python
-SPHINXOPTS    ?=
+SPHINXOPTS    ?= -j 1
 SPHINXBUILD   ?= python $(shell which sphinx-build)
 SPHINXCACHE   ?= build/doctrees
 PAPER         ?=
@@ -12,7 +12,8 @@
 PAPEROPT_a4     = -D latex_paper_size=a4
 PAPEROPT_letter = -D latex_paper_size=letter
 ALLSPHINXOPTS   = -d $(SPHINXCACHE) $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
-DEST = build
+DEST            = build
+
 .PHONY: all help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest gitwash gh-pages release_notes
 
 all: html
@@ -32,10 +33,13 @@
 	@echo "  linkcheck to check all external links for integrity"
 	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"
 	@echo "  gitwash   to update the gitwash documentation"
+
 clean:
-	-rm -rf $(DEST)/*
+	-rm -rf $(DEST)
+	-rm -rf api
 	-rm -rf source/api
 	-find ./source/auto_examples/* -type f | grep -v blank | xargs rm -f
+
 api:
 	@mkdir -p source/api
 	$(PYTHON) tools/build_modref_templates.py
@@ -43,7 +47,7 @@
 
 release_notes:
 	@echo "Copying release notes"
-	@tail -n +4 `ls release/*.txt | sort -k 2 -t . -n | tail -n 1` > release/_release_notes_for_docs.txt
+	@tail -n +4 `ls release/*.rst | sort -k 2 -t . -n | tail -n 1` > release/_release_notes_for_docs.rst
 
 html: api release_notes
 	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(DEST)/html
@@ -126,7 +130,7 @@
 gitwash:
 	$(PYTHON) tools/gitwash/gitwash_dumper.py source scikit-image \
 	--project-url=http://scikit-image.org \
-	--project-ml-url=http://groups.google.com/group/scikit-image \
+	--project-ml-url=https://mail.python.org/mailman/listinfo/scikit-image \
 	--repo-name=scikit-image \
 	--github-user=scikit-image \
-	--source-suffix=.txt
+	--source-suffix=.rst

=== debian/changelog ===
skimage (0.13.1-2) unstable; urgency=medium

  * Moved my changes for 0.13.1 into debian-science repo (Closes: #878848)
    - previous changelog was adjusted to reflect also changes introduced by
      the team

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 17 Oct 2017 07:55:38 -0400

skimage (0.13.1-1) unstable; urgency=medium

  * Team upload

  [ Michael Hudson-Doyle ]
  * New upstream release
    Closes: #868582
  * d/patches/:
    - changeset_6807f4ee8f5501703e447f95701190c836deaae1.diff,
      dask-optional-dep.patch, fix_shape_type.patch, search-html.patch: dropped,
      applied upstream.
    - fix-doc-links.patch: updated
    - skip_tests_failing_on_some_architectures.patch: split into more targetted
      skip-failing-test-on-i386.patch & skip-failing-test-on-big-endian.patch.
    Closes: #871095
  * d/rules: CONTRIBUTING.txt has moved.
  * d/control: add dependencies on python{3,}-pywt. python{3,}-numpydoc.

  [ Andreas Tille ]
  * debhelper 10
  * drop alternative python-imaging
    Closes: #866480
  * Standards-Version: 4.0.1 (no changes needed)

  [ Yaroslav Halchenko ]
  * Note that it is a redone changelog entry due to confusion among
    multiple packaging VCS.
  * Progressed to 0.13.1 upstream release
  * debian/patches
    - deb_no_sphinx_galery: to disable absent sphinx galery for now
  * Do not exclude test_tools.py in tests, but exclude test_update_on_save
    having issues with PIL 4.2.1
    (see https://github.com/scikit-image/scikit-image/issues/2843)

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 10 Oct 2017 18:26:16 -0400

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: skimage
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Stefan van der Walt <stefanv@berkeley.edu>,
            Yaroslav Halchenko <debian@onerussian.com>
 Build-Depends: cython (>= 0.23),
                cython3 (>= 0.23),
-               debhelper (>= 9~),
+               debhelper (>= 10),
                libjs-twitter-bootstrap,
                python-all-dev (>= 2.6.6-3~),
                python-matplotlib (>= 1.3.1),
@@ -15,7 +14,7 @@
                python-nose,
                python-numpy (>= 1.7.2),
                python-numpydoc,
-               python-pil (>= 1.7.8) | python-imaging,
+               python-pil (>= 1.7.8),
                python-pywt,
                python-scipy (>= 0.10),
                python-setuptools,
@@ -27,14 +26,14 @@
                python3-nose,
                python3-numpy (>= 1.7.2),
                python3-numpydoc,
-               python3-pil (>= 1.7.8) | python3-imaging,
+               python3-pil (>= 1.7.8),
                python3-pywt,
                python3-scipy,
                python3-setuptools,
                python3-six (>= 1.3.0),
                xauth,
                xvfb
-Standards-Version: 3.9.8
+Standards-Version: 4.0.1
 Homepage: http://scikit-image.org
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/skimage.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/skimage.git
@@ -46,7 +45,7 @@
 Depends: python-matplotlib (>= 1.3.1),
          python-networkx (>= 1.8),
          python-numpy,
-         python-pil (>= 1.7.8) | python-imaging,
+         python-pil (>= 1.7.8),
          python-scipy (>= 0.10),
          python-six (>= 1.4),
          python-skimage-lib (>= ${source:Version}),
@@ -66,7 +65,7 @@
 Depends: python3-matplotlib (>= 1.3.1),
          python3-networkx (>= 1.8),
          python3-numpy (>= 1.7.2),
-         python3-pil (>= 1.7.8) | python3-imaging,
+         python3-pil (>= 1.7.8),
          python3-scipy (>= 0.10),
          python3-six (>= 1.4),
          python3-skimage-lib (>= ${source:Version}),

=== debian/rules ===
--- 
+++ 
@@ -85,7 +85,7 @@
 endif
 
 override_dh_installdocs:
-	dh_installdocs -A CONTRIBUTORS.txt README.md CONTRIBUTING.txt TASKS.txt
+	dh_installdocs -A CONTRIBUTORS.txt README.md .github/CONTRIBUTING.txt TASKS.txt
 	dh_link -ppython-skimage-doc /usr/share/twitter-bootstrap/files/js/bootstrap.min.js \
 	    usr/share/doc/python-skimage-doc/html/_static/js/bootstrap.min.js
 	dh_link -ppython-skimage-doc /usr/share/twitter-bootstrap/files/css/bootstrap.min.css \

=== debian/tests/control ===
Tests: python2
Depends: python-all, python-nose, python-skimage, python-pil | python-imaging, python-matplotlib, python-tk, python-networkx, xauth, xvfb

Tests: python3
Depends: python3-all, python3-nose, python3-skimage, python3-pil | python3-imaging, python3-matplotlib, python3-tk, python3-networkx, xauth, xvfb

## skimage 0.14.0

=== debian/changelog ===
skimage (0.14.0-0ubuntu4) cosmic; urgency=medium

  * Cherrypick upstream test-suite assertion fixes for 32bit / soft-fp
    arches, fixes ftbfs on armhf and i386.
  * Further ignore interger overflow warning in one test.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 03 Oct 2018 11:27:56 +0100

skimage (0.14.0-0ubuntu3) cosmic; urgency=medium

  * No change rebuild to add support for Python 3.7.

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Fri, 10 Aug 2018 14:58:39 +1200

skimage (0.14.0-0ubuntu2) cosmic; urgency=medium

  * Patch upstream requirements so that dask won't become a Depends.
    (because python-dask is not available)
  * Add pytest to autopkgtest dependencies.
  * Allow outputs to stderr during autopkgtest.

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 27 Jun 2018 07:36:55 +0000

skimage (0.14.0-0ubuntu1) cosmic; urgency=medium

  * No-change backport to cosmic

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 26 Jun 2018 08:06:56 +0000

skimage (0.14.0-1) UNRELEASED; urgency=medium

  * New upstream version 0.14.0

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 25 Jun 2018 10:50:12 +0000

skimage (0.13.1-3) unstable; urgency=medium

  * Team upload.
  * Remove deprecated box-forced matplotlib parameter (by patch from upstream
      https://github.com/scikit-image/scikit-image/pull/2977)
    Closes: #895769
  * python-skimage-doc Depends: libjs-twitter-bootstrap
    Closese: #861498
  * cme fix dpkg-control
     - Standards-Version: 4.1.4
     - Point Vcs-fields to Salsa
     - Drop unneeded version restrictions
     - reformatting
  * Build-Depends: s/python-sphinx/python3-sphinx/
  * hardening=+all
  * Enhanced description for python-skimage-doc
  * Removed unneeded paragraphs from d/copyright
  * Add missing DEP3 descriptions

 -- Andreas Tille <tille@debian.org>  Tue, 24 Apr 2018 09:16:32 +0200

=== debian/control ===
Source: skimage
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Stefan van der Walt <stefanv@berkeley.edu>,
           Yaroslav Halchenko <debian@onerussian.com>
Section: python
Priority: optional
Build-Depends: cython (>= 0.23),
               cython3 (>= 0.23),
               debhelper (>= 10),
               libjs-twitter-bootstrap,
               python-all-dev,
               python-matplotlib (>= 1.3.1),
               python-networkx (>= 1.8),
               python-nose,
               python-numpy,
               python-numpydoc,
               python-pil,
               python-pytest,
               python-pywt,
               python-scipy,
               python-setuptools,
               python-six (>= 1.4),
               python3-sphinx (>= 1.3.0),
               python3-all-dev,
               python3-dask,
               python3-matplotlib,
               python3-networkx,
               python3-nose,
               python3-numpy,
               python3-numpydoc,
               python3-pil,
               python3-pytest,
               python3-pywt,
               python3-scipy,
               python3-setuptools,
               python3-six (>= 1.3.0),
               xauth,
               xvfb
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/science-team/skimage
Vcs-Git: https://salsa.debian.org/science-team/skimage.git
Homepage: http://scikit-image.org
X-Python-Version: >= 2.6
X-Python3-Version: >= 3.2

Package: python-skimage
Architecture: all
Depends: python-matplotlib (>= 1.3.1),
         python-networkx (>= 1.8),
         python-numpy,
         python-pil,
         python-scipy,
         python-six (>= 1.4),
         python-skimage-lib (>= ${source:Version}),
         ${misc:Depends},
         ${python:Depends}
Recommends: python-nose,
            python-qt4
Suggests: python-opencv,
          python-skimage-doc
Description: Python modules for image processing
 scikit-image is a collection of image processing algorithms for
 Python.  It performs tasks such as image loading, filtering,
 morphology, segmentation, color conversions, and transformations.
 .
 This package provides the Python 2 module.

Package: python3-skimage
Architecture: all
Depends: python3-matplotlib,
         python3-networkx,
         python3-numpy,
         python3-pil,
         python3-scipy,
         python3-six (>= 1.4),
         python3-skimage-lib (>= ${source:Version}),
         ${misc:Depends},
         ${python3:Depends}
Recommends: python3-nose
Suggests: python-skimage-doc
Description: Python 3 modules for image processing
 scikit-image is a collection of image processing algorithms for
 Python.  It performs tasks such as image loading, filtering,
 morphology, segmentation, color conversions, and transformations.
 .
 This package provides the Python 3 module.

Package: python-skimage-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Suggests: python-skimage
Description: Documentation and examples for scikit-image
 scikit-image is a collection of image processing algorithms for
 Python.  It performs tasks such as image loading, filtering,
 morphology, segmentation, color conversions, and transformations.
 .
 This package contains documentation and example scripts for
 python-skimage.

Package: python-skimage-lib
Architecture: any
Depends: python-numpy,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: python-skimage
Provides: ${python:Provides}
Description: Optimized low-level algorithms for scikit-image
 This is an add-on package for python-skimage. It provides
 optimized, low-level implementations of algorithms.
 .
 This package provides the Python 2 libraries.

Package: python3-skimage-lib
Architecture: any
Multi-Arch: same
Depends: python3-numpy,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-skimage
Description: Optimized low-level algorithms for Python 3 scikit-image
 This is an add-on package for python-skimage. It provides
 optimized, low-level implementations of algorithms.
 .
 This package provides the Python 3 libraries.

=== debian/rules ===
--- 
+++ 
@@ -19,6 +19,8 @@
 
 export http_proxy = http://127.0.9.1:9
 export https_proxy = http://127.0.9.1:9
+
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 # Mega rule
 %:
@@ -44,7 +46,7 @@
 ifneq (,$(findstring -a,$(DH_INTERNAL_OPTIONS)))
 	: # not building documentation in -a
 else
-	export PYTHONPATH=$(PKG_TMP)/usr/lib/python$(PYVER)/dist-packages; \
+	export PYTHONPATH=$(PKG_TMP)/usr/lib/python3/dist-packages; \
 	 cd doc; test -d build/html || $(MAKE) html
 endif
 endif
@@ -81,11 +83,14 @@
 	: # no documentation in -a -- surprised that sphinxdoc doesn't know that
 else
 	dh_sphinxdoc -ppython-skimage-doc
+	find debian -type f -exec sed -i -e \
+		's@https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js@file:///usr/share/javascript/mathjax/MathJax.js@g' \
+		'{}' +
 endif
 endif
 
 override_dh_installdocs:
-	dh_installdocs -A CONTRIBUTORS.txt README.md .github/CONTRIBUTING.txt TASKS.txt
+	dh_installdocs -A CONTRIBUTORS.txt README.md CONTRIBUTING.txt TODO.txt
 	dh_link -ppython-skimage-doc /usr/share/twitter-bootstrap/files/js/bootstrap.min.js \
 	    usr/share/doc/python-skimage-doc/html/_static/js/bootstrap.min.js
 	dh_link -ppython-skimage-doc /usr/share/twitter-bootstrap/files/css/bootstrap.min.css \

=== debian/tests/control ===
Tests: python2
Depends: python-all, python-nose, python-skimage, python-pil | python-imaging, python-matplotlib, python-tk, python-networkx, xauth, xvfb, python-pytest
Restrictions: allow-stderr

Tests: python3
Depends: python3-all, python3-nose, python3-skimage, python3-pil | python3-imaging, python3-matplotlib, python3-tk, python3-networkx, xauth, xvfb, python3-pytest, python3-dask
Restrictions: allow-stderr

## skimage 0.14.1

=== debian/changelog ===
skimage (0.14.1-2) unstable; urgency=medium

  * Team upload
  * Overhaul rules and fix FTBFS on Architecture=all.
  * Fix parallel build by adding debian/process_pyx.py and
    debian/patches/fix-wrong-condition-on-prebuilt-c-files.patch
  * Move build dependencies for doc package to Build-Depends-Indep.
  * Switch matplotlib backend to Agg (export MPLBACKEND := Agg) and
    drop build dependency on xauth and xvfb.

 -- Yangfl <mmyangfl@gmail.com>  Fri, 19 Oct 2018 08:25:27 +0000

skimage (0.14.1-1) unstable; urgency=medium

  * Team upload

  [ Mo Zhou ]
  * Fixup testsuite (Closes: #902480).
  * Add new deps to debian/tests/control
  * Allow stderr during autopkgtest, some libraries are
    throwing warnings as errors during autopkgtests.
  * Remove deprecated X-Python*-Version fields.
  * Run dh_auto_tests with xvfb-run.

  [ Yangfl <mmyangfl@gmail.com> ]
  * New upstream release (Closes: #906207)
  * d/compat
    - bump debhelper compat to 11
  * d/control
    - remove build dep libjs-twitter-bootstrap (Closes: #908433)
    + build dep python-tk and python3-tk
    + build dep python3-sphinx-gallery and python3-sklearn, required by doc
      building
    + build dep python3-doc and python-matplotlib-doc for intersphinx mappings
    + dep libjs-{bootstrap,jquery,mathjax} for python-skimage-doc
    * bump standard to 4.2.1
  * d/copyright
    - no need to remove bootstrap.min.js, provided in missing-sources
  * d/rules
    - switch from python_distutils to pybuild
    - hotfix broken sphinx build command by passing SPHINXBUILD manually
      (Closes: #902478)
    - replace MathJax.js with local file (Closes: #902479)
  * d/patches
    - remove 0001-BF-perform-computation-serially-with-a-warning-if-da.patch
      and skip-failing-test-on-i386.patch since included in new release
    - add allow-warnings-on-dask.patch to bypass false alert on dask missing
    - remove deb_no_sphinx_galery since python3-sphinx-gallery available
    - add no-download-intersphinx-mapping.patch

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 17 Oct 2018 11:33:00 +0000

skimage (0.14.0-1) unstable; urgency=medium

  * Fresh upstream release
    - should resolve FTBFS due to incompatibility with NumPy 1.14
      (Closes: #901377)
  * d/patches
    - refreshed patches skipping on some archs.  Use testing.skipif instead
      of explicit import of skipif into the namespace
    - removed remove_deprecated_box-forced.patch - was CPed from upstream
    - added 0001-BF-perform-computation-serially-with-a-warning-if-da.patch
      to make skimage not crash whenever dask is not available
    - added deb_no_dask_in_setup to not demand dask at setup.py leve since
      not available for python2 in Debian
  * d/tests,control
    - upstream uses pytest instead of nose now
  * d/control
    - recommend and b-depend on python3-dask
  * d/rules
    - use python3 to build docs since some helper scripts are python3 only
    - cleanup __pycache__ which might appear after running tests

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 25 Jun 2018 12:26:51 -0400

=== debian/control ===
--- 
+++ 
@@ -1,48 +1,46 @@
 Source: skimage
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Stefan van der Walt <stefanv@berkeley.edu>,
            Yaroslav Halchenko <debian@onerussian.com>
 Section: python
 Priority: optional
-Build-Depends: cython (>= 0.23),
-               cython3 (>= 0.23),
-               debhelper (>= 10),
-               libjs-twitter-bootstrap,
+Build-Depends: cython3 (>= 0.23),
+               debhelper (>= 11~),
+               dh-python,
                python-all-dev,
                python-matplotlib (>= 1.3.1),
                python-networkx (>= 1.8),
-               python-nose,
+               python-pytest,
                python-numpy,
                python-numpydoc,
                python-pil,
-               python-pytest,
                python-pywt,
                python-scipy,
                python-setuptools,
                python-six (>= 1.4),
-               python3-sphinx (>= 1.3.0),
+               python-tk,
                python3-all-dev,
                python3-dask,
                python3-matplotlib,
                python3-networkx,
-               python3-nose,
+               python3-pytest,
                python3-numpy,
                python3-numpydoc,
                python3-pil,
-               python3-pytest,
                python3-pywt,
                python3-scipy,
                python3-setuptools,
                python3-six (>= 1.3.0),
-               xauth,
-               xvfb
-Standards-Version: 4.1.4
+               python3-tk,
+Build-Depends-Indep: python3-sphinx (>= 1.3.0),
+                     python3-sphinx-gallery,
+                     python3-doc,
+                     python-matplotlib-doc,
+                     python3-sklearn,
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/science-team/skimage
 Vcs-Git: https://salsa.debian.org/science-team/skimage.git
 Homepage: http://scikit-image.org
-X-Python-Version: >= 2.6
-X-Python3-Version: >= 3.2
 
 Package: python-skimage
 Architecture: all
@@ -55,10 +53,11 @@
          python-skimage-lib (>= ${source:Version}),
          ${misc:Depends},
          ${python:Depends}
-Recommends: python-nose,
+Recommends: python-pytest,
             python-qt4
 Suggests: python-opencv,
           python-skimage-doc
+Provides: ${python:Provides}
 Description: Python modules for image processing
  scikit-image is a collection of image processing algorithms for
  Python.  It performs tasks such as image loading, filtering,
@@ -77,8 +76,10 @@
          python3-skimage-lib (>= ${source:Version}),
          ${misc:Depends},
          ${python3:Depends}
-Recommends: python3-nose
+Recommends: python3-pytest,
+         python3-dask,
 Suggests: python-skimage-doc
+Provides: ${python3:Provides}
 Description: Python 3 modules for image processing
  scikit-image is a collection of image processing algorithms for
  Python.  It performs tasks such as image loading, filtering,
@@ -91,8 +92,11 @@
 Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends},
-         ${sphinxdoc:Depends}
-Suggests: python-skimage
+         ${sphinxdoc:Depends},
+         libjs-bootstrap,
+         libjs-jquery,
+         libjs-mathjax,
+Built-Using: ${sphinxdoc:Built-Using},
 Description: Documentation and examples for scikit-image
  scikit-image is a collection of image processing algorithms for
  Python.  It performs tasks such as image loading, filtering,
@@ -123,6 +127,7 @@
          ${python3:Depends},
          ${shlibs:Depends}
 Recommends: python3-skimage
+Provides: ${python3:Provides}
 Description: Optimized low-level algorithms for Python 3 scikit-image
  This is an add-on package for python-skimage. It provides
  optimized, low-level implementations of algorithms.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

PACKAGE2_NAME = python-skimage
PACKAGE3_NAME = python3-skimage
PKG_TMP = $(CURDIR)/debian/tmp

# don't optimize pngs, palette changes break tests and documented examples
export NO_PNG_PKG_MANGLE=1

PY2VERS = $(shell pyversions -vr)
PY3VER = $(shell py3versions  -vd)
PY3VERS = $(shell py3versions -vr)

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

# upstream relies on signed chars
export DEB_CFLAGS_MAINT_APPEND := -fsigned-char
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  JOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
  JOBS = 1
endif

# Assure Agg backend for matplotlib to avoid any possible complication
export MPLBACKEND := Agg


%:
	dh $@ --with python2,python3,sphinxdoc --buildsystem pybuild

%-arch:
	dh $@ --with python2,python3 --buildsystem pybuild

clean:
	dh $@ --with python2,python3 --buildsystem pybuild

# silly distutils does not support parallelism! waste hours of time
.PHONY: build
build-arch: $(addprefix debian/build-stamp-python,$(PY2VERS)) $(addprefix debian/build-stamp-python,$(PY3VERS))
	:
build build-indep: build-arch doc/build/html
	:

debian/build-stamp-python%: debian/build-stamp-pyx
	PYBUILD_INTERPRETERS=python{version} \
	PYBUILD_VERSIONS=$* \
	PYBUILD_TEST_PYTEST=1 \
	dh build-arch --with python$(basename $*) --buildsystem pybuild
	touch $@

override_dh_clean:
	dh_clean
	rm -rf .pytest_cache build scikit_image.egg-info
	rm -f debian/build-stamp-*
	for i in $$(find -name '*.md5'); do \
		rm -f $${i%.pyx.md5}.c $${i%.pyx.md5}.cpp $$i; \
	done
	for i in $$(find -name '*.pyx.in'); do \
		rm -f $${i%.*}; \
	done
ifeq (,$(findstring -a,$(DH_INTERNAL_OPTIONS)))
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	+$(MAKE) -C doc clean
	rm -f doc/source/_static/random.js
endif
endif

debian/build-stamp-pyx: debian/bin/process_pyx.py
	python3 $< $(JOBS)
	touch $@

doc/build/html: debian/build-stamp-python$(PY3VER)
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	# hotfix SPHINXBUILD -- remove in next release
	+\
		PYTHONPATH=$(CURDIR)/.pybuild/cpython3_$(PY3VER)/build:$$(python3 -c 'import sys;print(":".join(sys.path))') \
		PYTHON=python$(PY3VER) \
		SPHINXBUILD="python$(PY3VER) -m sphinx" \
		SPHINXOPTS="-j $(JOBS) -D mathjax_path=MathJax.js" \
		$(MAKE) -C doc html
endif
	touch $@

# Test data and plugin ini not copied to .pybuild -- manually link for them
override_dh_auto_test-arch:
	for ver in $(PYBUILD_VERSIONS); do \
		i=.pybuild/cpython$${ver%.*}_$$ver/build/skimage; \
		cp skimage/io/_plugins/*.ini $$i/io/_plugins/; \
		rm -rf $$i/data || true; \
		ln -sf ../../../../skimage/data $$i; \
		for module in $$(find skimage ! -path '*/data/*' -name tests | cut -sd / -f 2-); do \
			rm -rf $$i/$$module || true; \
			ln -sf $(CURDIR)/skimage/$$module $$i/$${module%/*}/; \
		done; \
	done
	dh_auto_test

override_dh_auto_install:
	dh_auto_install
	# cleanup python3 cache (mixing python3 subversions)
	-find $(PKG_TMP) -name "__pycache__" -exec rm -r {} +

## remove .so libraries from main package, and call dh_numpy*
_dh_python%:
	-find debian/$(PACKAGE$*_NAME)/usr/lib -name "*.so" -delete

	dh_numpy$(*:2=) -p$(PACKAGE$*_NAME)-lib
	dh_python$*

override_dh_python2: _dh_python2
override_dh_python3: _dh_python3

## immediately useable documentation and exemplar scripts/data
override_dh_compress:
	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc

override_dh_sphinxdoc-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_sphinxdoc -XMathJax.js
endif

override_dh_installdocs:
	dh_installdocs -A CONTRIBUTORS.txt README.md CONTRIBUTING.txt
